# 2.6.x Stable Releases

## 2.6.1 (Sep 15, 2021)

The second stable release of the `2.6.x` series, with no changes since the previous rc!

## 2.6.1rc3 (Sep 05, 2021)

### Bug fixes

* Fix UI rendering when a workunit has completed children but no running children (cherrypick of #12748) ([#12752](https://github.com/pantsbuild/pants/pull/12752))

* Include `.gitignore` in default `pantsd_invalidation_globs` (#12711) ([#12730](https://github.com/pantsbuild/pants/pull/12730))

### Documentation

* Fix Toolchain plugin being included in generated reference docs (Cherry-pick of #12642) ([#12647](https://github.com/pantsbuild/pants/pull/12647))

## 2.6.1rc2 (Aug 24, 2021)

### New Features

* Default to `my-dep-stubs` and `stubs-my-dep` being third-party type stubs (Cherry-pick of #12598) ([#12600](https://github.com/pantsbuild/pants/pull/12600))

### Bug fixes

* Fix `FindBinary` when `which` is discoverable on `$PATH` on macOS (Cherry-pick of #12581) ([#12631](https://github.com/pantsbuild/pants/pull/12631))

* pyenv should fall back to $HOME/.pyenv (Cherry-pick of #12527) ([#12628](https://github.com/pantsbuild/pants/pull/12628))

### Documentation

* Embrace that help strings are markdown. (#12606) ([#12608](https://github.com/pantsbuild/pants/pull/12608))

## 2.6.1rc1 (Aug 16, 2021)

### Bug fixes

* Fix shlexing of passthrough args. (#12547) ([#12551](https://github.com/pantsbuild/pants/pull/12551))

### Performance

* Stream files into the local store while capturing them (cherrypick of #12563) ([#12572](https://github.com/pantsbuild/pants/pull/12572))

## 2.6.1rc0 (Aug 06, 2021)

### New Features

* Add `skip_tests` field to `python_tests` to facilitate incremental migrations (Cherry-pick of #12510) ([#12511](https://github.com/pantsbuild/pants/pull/12511))

* Adds support for Poetry group dependencies (Cherry-pick of #12492) ([#12497](https://github.com/pantsbuild/pants/pull/12497))

### User API Changes

* Add to default module mapping: Django extensions, Google Cloud, Pillow, and python-dotenv (Cherry-pick of #12506) ([#12507](https://github.com/pantsbuild/pants/pull/12507))

### Bug fixes

* Make the pantsd crash error message more precise. (#12512) ([#12513](https://github.com/pantsbuild/pants/pull/12513))

* Resolve plugins using the PEX --python option. (cherrypick of #12500) ([#12504](https://github.com/pantsbuild/pants/pull/12504))

* Shield isolated-Sessions / StreamingWorkunitHandlers from Ctrl+C. (cherrypick of #12483) ([#12485](https://github.com/pantsbuild/pants/pull/12485))

### Performance

* Don't resolve constraints file / lockfile if no 3rd-party requirements used (Cherry-pick of #12488) ([#12490](https://github.com/pantsbuild/pants/pull/12490))

## 2.6.0 (Jul 30, 2021)

The first stable release of the `2.6.x` series, with no changes since the previous `rc`!

## 2.6.0rc4 (Jul 27, 2021)

### New Features

* Add option for async completion of StreamingWorkunitHandlers, disable by default in containers (Cherry-pick of #12392) ([#12399](https://github.com/pantsbuild/pants/pull/12399))

### Performance

* Skip preparation of workunit log messages which will never be rendered. (Cherry-pick of #12396) ([#12400](https://github.com/pantsbuild/pants/pull/12400))

* Do not upload Action inputs for remote cache writes. (Cherry-pick of #12443) ([#12444](https://github.com/pantsbuild/pants/pull/12444))

### Documentation

* Clarify when we are subsetting the lockfile for 3rdparty dependencies (Cherry-pick of #12435) ([#12439](https://github.com/pantsbuild/pants/pull/12439))

* Fix the content type for Pants' wheel long_descriptions. (Cherry-pick of #12391) ([#12402](https://github.com/pantsbuild/pants/pull/12402))

## 2.6.0rc3 (Jul 20, 2021)

### User API Changes

* Add `[python-setup].interpreter_versions_universe` to ensure Pants works robustly with future Python interpreters (Cherry-pick of #12379) ([#12383](https://github.com/pantsbuild/pants/pull/12383))

### Bug fixes

* More robust support for Poetry dependency attributes (`markers` and`extras`) (Cherry-pick of #12323) ([#12385](https://github.com/pantsbuild/pants/pull/12385))

* Mark workunits blocked, and skip rendering completed workunits (#12369) ([#12376](https://github.com/pantsbuild/pants/pull/12376))

* Fix anonymous telemetry logging. ([#12344](https://github.com/pantsbuild/pants/pull/12344))

### Performance

* Reduce # of resolves when packaging pex_binary and python_awslambda targets (Cherry-pick of #12343) ([#12350](https://github.com/pantsbuild/pants/pull/12350))

## 2.6.0rc2 (Jul 08, 2021)

### Bug fixes

* Set up pants to use the latest version of humbug ([#12303](https://github.com/pantsbuild/pants/pull/12303))

## 2.6.0rc1 (Jul 7, 2021)

### New Features

* Add support for MyPy report files (Cherry-pick of #12271) ([#12289](https://github.com/pantsbuild/pants/pull/12289))

### Bug fixes

* Hotfix `poetry_requirements` not being recognized as a macro in BUILD files (Cherry-pick of #12263) ([#12264](https://github.com/pantsbuild/pants/pull/12264))

* Do not use `[python-setup].resolve_all_constraints` when using `platforms` (Cherry-pick of #12268) ([#12269](https://github.com/pantsbuild/pants/pull/12269))

* Fix poetry_requirements: ignore internal projects. (Cherry-pick of #12280) ([#12296](https://github.com/pantsbuild/pants/pull/12296))

* Fix poetry_requirements handling of python. (#12278) ([#12282](https://github.com/pantsbuild/pants/pull/12282))

* Include experimental Go backends in pantsbuild.pants (Cherry-pick of #12290) ([#12291](https://github.com/pantsbuild/pants/pull/12291))

### Documentation

* Change how we embed docsite links in help text (Cherry-pick of #12261) ([#12266](https://github.com/pantsbuild/pants/pull/12266))

## 2.6.0rc0 (Jun 30, 2021)

### New Features

* Add dependency inference for Python third-party type stubs ([#12248](https://github.com/pantsbuild/pants/pull/12248))

* Add `poetry_requirements` macro for Poetry support ([#12174](https://github.com/pantsbuild/pants/pull/12174))

### User API Changes

* Update default MyPy to 0.910 ([#12249](https://github.com/pantsbuild/pants/pull/12249))

* Update linter versions for `pylint`, `black`, `bandit` ([#12135](https://github.com/pantsbuild/pants/pull/12135))

* Upgrade Go distribution to v1.16.5 ([#12247](https://github.com/pantsbuild/pants/pull/12247))

### Plugin API Changes

* Set default user-agent header on gRPC requests with Pants version ([#12241](https://github.com/pantsbuild/pants/pull/12241))

* Increment counter on missing file digests ([#12235](https://github.com/pantsbuild/pants/pull/12235))

### Bug fixes

* Add support for multiple requirements for a single package name in the `python_requirements` macro ([#12232](https://github.com/pantsbuild/pants/pull/12232))

* Fix dependency inference to be ambiguous when >1 type stub for same module ([#12244](https://github.com/pantsbuild/pants/pull/12244))

* Hash the `repo_id` in the tag. ([#12151](https://github.com/pantsbuild/pants/pull/12151))

* Fix `skip_tool` not working with `./pants fmt` if all files are skipped ([#12230](https://github.com/pantsbuild/pants/pull/12230))

## 2.6.0.dev2 (Jun 16, 2021)

### New Features

* Adds `--[no-]watch-filesystem` switch ([#12210](https://github.com/pantsbuild/pants/pull/12210))

### User API Changes

* Deprecate unused `interpreter_constraints` field for `python_awslambda` ([#12208](https://github.com/pantsbuild/pants/pull/12208))

### Plugin API Changes

* Rename remote cache write start and finished metrics ([#12202](https://github.com/pantsbuild/pants/pull/12202))

* Support for custom target types in tailor. ([#12156](https://github.com/pantsbuild/pants/pull/12156))

### Bug fixes

* Fallback to `[python-setup].interpreter_constraints` for `python_distribution` targets with no first-party dependencies ([#12207](https://github.com/pantsbuild/pants/pull/12207))

* Fix remote cache write attempts metric to record even if write does not finish ([#12204](https://github.com/pantsbuild/pants/pull/12204))

* Fix Process output capture re: working_directory. ([#12197](https://github.com/pantsbuild/pants/pull/12197))

* Fix `Key` interning race. ([#12152](https://github.com/pantsbuild/pants/pull/12152))

### Documentation

* Fix relocated files help display. ([#12185](https://github.com/pantsbuild/pants/pull/12185))

* Suggest `-ldebug` and `--no-process-execution-local-cleanup` in exception messages ([#12180](https://github.com/pantsbuild/pants/pull/12180))

## 2.6.0.dev1 (May 29, 2021)

### New Features

* Allow setting `--pantsd-max-memory-usage` with `GiB`, `MiB`, and `KiB` units ([#12123](https://github.com/pantsbuild/pants/pull/12123))

* Register `strip_pex_env` field with pex_binary. ([#12147](https://github.com/pantsbuild/pants/pull/12147))

### User API Changes

* Fix `[python-setup].resolver_jobs` default value to better recognize containers ([#12139](https://github.com/pantsbuild/pants/pull/12139))

* Deprecate broken [lint].reports_dir and make mechanism more flexible ([#12122](https://github.com/pantsbuild/pants/pull/12122))

* Change Docformatter to not try to use Python 2 and Python 3.5 by default ([#12099](https://github.com/pantsbuild/pants/pull/12099))

### Plugin API Changes

* Allow overriding option default help display. ([#12128](https://github.com/pantsbuild/pants/pull/12128))

* Rename `ProcessCacheScope.NEVER` to `ProcessCacheScope.PER_SESSION` ([#12100](https://github.com/pantsbuild/pants/pull/12100))

* Replace `ProcessCacheScope.PER_RESTART` with `ProcessCacheScope.PER_RESTART_ALWAYS` and `ProcessCacheScope.PER_RESTART_SUCCESSFUL` ([#12094](https://github.com/pantsbuild/pants/pull/12094))

### Performance

* add retries for reads and writes from remote CAS ([#12132](https://github.com/pantsbuild/pants/pull/12132))

* Fix --coverage-py-global-report for >9 test files. ([#12144](https://github.com/pantsbuild/pants/pull/12144))

### Documentation

* Clarify the default values for parallelism options ([#12119](https://github.com/pantsbuild/pants/pull/12119))

* Make timeouts in tests less confusing ([#12120](https://github.com/pantsbuild/pants/pull/12120))

* Rewrite error message when Pantsd is shut down during run ([#12107](https://github.com/pantsbuild/pants/pull/12107))

* Fix scheduler initialization log ([#12105](https://github.com/pantsbuild/pants/pull/12105))

## 2.6.0.dev0 (May 19, 2021)

### New Features

* Add support for global coverage reports. ([#12080](https://github.com/pantsbuild/pants/pull/12080))

* Add `extra_env_vars` capability to `python_tests()` ([#12022](https://github.com/pantsbuild/pants/pull/12022))

* Add `pex_binary` support for `--no-strip-pex-env`. ([#12061](https://github.com/pantsbuild/pants/pull/12061))

### User API Changes

* Remove deprecated `[pytest].config` in favor of `[pytest].config_discovery` ([#12033](https://github.com/pantsbuild/pants/pull/12033))

* Remove deprecated `ignore_pants_warnings` in favor of `ignore_warnings` ([#12032](https://github.com/pantsbuild/pants/pull/12032))

* Enforce `[python-setup].resolve_all_constraints` being a bool option ([#12034](https://github.com/pantsbuild/pants/pull/12034))

* Remove experimental and unused `[python-setup].requirement_constraints_target` option and `_python_constraints` target ([#11998](https://github.com/pantsbuild/pants/pull/11998))

### Plugin API Changes

* Rename `PexInterpreterConstraints` to `InterpreterConstraints` and move to dedicated file ([#12021](https://github.com/pantsbuild/pants/pull/12021))

* Add plugin hook for setting up Pytest context ([#12091](https://github.com/pantsbuild/pants/pull/12091))

* Auth plugins can inspect the prior result, set an expiration, and override `--remote-{store,execution}-address` ([#12029](https://github.com/pantsbuild/pants/pull/12029))

### Bug fixes

* Fix `--remote-auth-plugin` and `--remote-oauth-bearer-token-path` to execute every run with Pantsd ([#12020](https://github.com/pantsbuild/pants/pull/12020))

* Fix `module_mapping` to work regardless of capitalization and `-` vs `_` ([#12068](https://github.com/pantsbuild/pants/pull/12068))

* Fix `PEX_ROOT` leak with run and repl goals. ([#12066](https://github.com/pantsbuild/pants/pull/12066))

* Fix constraints resolves to pass additional args. ([#12076](https://github.com/pantsbuild/pants/pull/12076))

* Fix `skip_tool` fields not working with `./pants fmt` ([#12073](https://github.com/pantsbuild/pants/pull/12073))

* Fix Python run for apps that re-exec themselves. ([#12060](https://github.com/pantsbuild/pants/pull/12060))

* Fix remote cache writes memory exhaustion. ([#12087](https://github.com/pantsbuild/pants/pull/12087))

* Halve memory usage for remote cache writes. ([#12083](https://github.com/pantsbuild/pants/pull/12083))

* Fix Shell dependency inference not caching ([#12052](https://github.com/pantsbuild/pants/pull/12052))
